// AAT3151 lib (AS2Cwire interface)

//     -
#define aat3151_port	PORTC
#define aat3151_ddr	DDRC
#define aat3151_pin        7

// 
void aat3151_send_pulses (unsigned char pulse);				//    N  
void aat3151_write_register (unsigned char reg, unsigned char data); 	//    
void aat3151_select_register (unsigned char reg); 			//  
void aat3151_write_data (unsigned char data); 				//  
void aat3151_sleep (void); 						//     ( c   )
void aat3151_init (void); 						//      

//   (  )
#define D1D4current	17	
#define D1D3current     18
#define D4current       19
#define MAXcurrent      20
#define LOWcurrent      21

//    ( ),    MAXcurrent
#define scale20mA	1	// default 
#define scale30mA	2
#define scale15mA       3
#define scale_low       4

//        15    5,2
#define scale_default	3	// ,    init - 15 
#define current_default	10	// ,    init - 5,2   15

//       LOWcurrent,    LOWcurrent 
#define current_0_all	1
#define current_005_d1	9
#define current_05_d1	10
#define current_1_d1	11
#define current_2_d1	12
#define current_005_d4	5
#define current_05_d4	6
#define current_1_d4	7
#define current_2_d4	8
#define current_005_all	13
#define current_05_all	14
#define current_1_all	15
#define current_2_all	16

//       scalexxmA   16  ( ),
// 1 -   , 16 - 0 
//   - . 

//  N   ,      	
void aat3151_send_pulses (unsigned char pulse)
	{
	while (pulse > 0)
		{
		pulse--;
		aat3151_port.aat3151_pin = 1;
		#asm("nop");
		if (pulse) aat3151_port.aat3151_pin = 0;	//     ,    1
		//#asm("nop");
		}
	}

//    
void aat3151_write_register (unsigned char reg, unsigned char data)
	{
	aat3151_port.aat3151_pin = 0;   //    0
        aat3151_send_pulses (reg);
	delay_us(500);			//    
	aat3151_port.aat3151_pin = 0;
	aat3151_send_pulses (data);
	delay_us(500);
	}
        
//  
void aat3151_select_register (unsigned char reg)
	{
	aat3151_port.aat3151_pin = 0;
        aat3151_send_pulses (reg);
	delay_us(500);		
	}
        
//  
void aat3151_write_data (unsigned char data)
	{
	aat3151_port.aat3151_pin = 0;
	aat3151_send_pulses (data);
	delay_us(500);
	}        

//     ( c   )
void aat3151_sleep (void)
	{
        aat3151_port.aat3151_pin = 0;
	delay_us(550);
        }
        
//      
void aat3151_init (void)
	{
	aat3151_port.aat3151_pin = 0;	//   0
	aat3151_ddr.aat3151_pin = 1;	//    

        aat3151_write_register (MAXcurrent, scale_default);
        aat3151_write_register (D1D4current, current_default);
	}



















